#include "binko.h"

double Binko(double n, double k)
{
 double i, erg, zaehler, nenner;
   erg = 1;
   zaehler = n -k + 1;
   nenner = 1;

 for(i=1; i<= k; i++)
  erg *=zaehler++/nenner++;

return erg;
}

double Gross_gx(int n, double x, double p)
{
 double gx = 0, bk, Phi, eminp, nmini, f4, f5, i;
   
 
 for (i = 0; i <= x; i++)
 { 
  bk = Binko(n, i);
  Phi = pow(p, i);
  eminp = 1 - p;
  nmini = n - i;
  f4 = pow(eminp, nmini);
  f5 = bk * Phi * f4;
  gx += f5;
 }

return gx;
}

double Klein_gx(int n, double x, double p)
{
 double bk, px, f1, minp,nminx,f2;
 
 bk = Binko(n, x);

 px = pow(p, x);
 f1 = bk * px;
 minp = 1 - p;
 nminx = n - x;
 f2 = pow(minp, nminx);

return f2 * f1;
}