#ifndef CHIIDISB_INC_
#define CHIIDISB_INC_ 3

#include <iostream>
#include <iomanip>
#include <math.h>

#define OEG 0.005
#define OWG 0.025
#define UWG 0.975
#define UEG 0.995  

double factorial(double n);
int gerade(int x);

//double gamma(double n);
double chi_square_distribution(double x, double v);  // chi square distribution function (v.1)
double chivert(double x, int n);
double _chi_square_distribution(double x, double v);  // chi square distribution function (v.2)
double search_chi_square(double x, double h, double p, double v); // recursio search chi square inverse
double chi_square_inverse(double p, double v); 
double suche_chiinv(double x, double h, double p, double v);  // Recursive Suche von chi square inverse
double chiinv(double p, double v); // chi square inverse
double Get_sKartenLimit(double limit, int n);
double sKarte_anWert(int n);


#endif