// main.cpp von norminvcpp
#include <iostream>
#include <iomanip>
#include "norminv.h"
#include "chiidisb.h"
#include "menuefrage.h"
#include "normsvert.h"
#include "binko.h"
#include "doubleout.h"
#include "poisson.h"

int main()
{
 NormalDistributionConfidenceCalculator nvt;
 int wouhi = 11;
 double my, x, sigma = 1, guqu, wert, innen, alpha, n, konfi, Ee, Ew;
 double an, oe,ow,uw,ue, kgx, ggx, xgross, xklein, mue = 0; 
 double gu; 
 
 do
 switch(wouhi)
 {
   default:
       std::cout << std::endl << "Standardisierte Normalverteilung  V0.02" << std::endl;
       std::cout << "Ende...........................0" << std::endl;
       std::cout << "Werte Normert Berechnen........1" << std::endl;
	   std::cout << "Werte Norminv Berechnen........2" << std::endl;
       std::cout << "Konfidenz Test.................3" << std::endl;
       std::cout << "Konfidenzliste Test............4" << std::endl;
       std::cout << "CHI-Verteilung Test............5" << std::endl;
       std::cout << "CHI s-Karten-Werte.............6" << std::endl;
       std::cout << "NORM_S_VERT z=1.333............7" << std::endl;
       std::cout << "Binonialverteilung Beispiel....8" << std::endl;
       std::cout << "Poissonverteilung berechnen....9" << std::endl;
       wouhi = MenueFrage();
       if ((wouhi < 0 ) || (wouhi > 9)) wouhi = 1;
     break;

case 0:
       std::cout << "Programmende " << std::endl;
       return EXIT_SUCCESS;
    break;

case 1:
   std::cout << "My eingeben: ";
   std::cin >> my;
   std::cout << " x eingeben: ";
   std::cin >> x;
   std::cout <<" sigma: ";
   std::cin >> sigma;
   if((sigma <= 0) || (sigma > 1)) sigma = 1;
		
 
	 
   wert = nvt.NormalDistribution(my, x, 1);
   innen = 1 - wert;
   std::cout.precision(14);
   std::cout << "Q(u).....: " << std::fixed << wert<< std::endl;
   std::cout << "G(u).....: " << std::fixed << innen << std::endl; 
   std::cout << "G(u)-Q(u): " << std::fixed << innen - wert << std::endl; 
   std::cout << "g(u).....: " << nvt.NORM_S_VERT(x - my) << std::endl;
   wouhi = 11;

  break;

  case 2:
   std::cout << "G(u)-Q(u): ";
   std::cin >> guqu;

   if((guqu <= 0) || (guqu > 1)) sigma = 0.995;
		
   std::cout << "my = " << my << "   x=" << x << std::endl;
   //wert = nvt.NormalDistribution(0.0L, 0.0L, 1);
   wert = ((1 - guqu) / 2);	
   innen = 1 - wert;		 

   std::cout.precision(14);
   std::cout << "G(u) g(u): " << nvt.NormInv(innen) << std::endl; // G(u) als arg	 
   std::cout << "G(u).....: " << std::fixed << innen << std::endl; 		 
   std::cout << "Q(u).....: " << std::fixed << wert<< std::endl;
   std::cout << "G(u)-Q(u): " << std::fixed << innen - wert << std::endl; 
   
   wouhi = 11;
  break;
	 
     
  case 3:
   std::cout << "Konfidenztest" << std::endl;
   std::cout << "alpha(z.B. 0.05): ";
   std::cin >> alpha;
   clpuf();
   std::cout << "Stichprobengroesse(ganzzahlig): ";
   std::cin >> n;
   clpuf();
   std::cout << "Sigma: ";
   std::cin >> sigma;
   
   
   //alpha = 0.05;
   //n = 10;
   //sigma = 1; 
   
   std::cout << "alpha= " << alpha << "n= " << n <<  "  sigma=" << sigma <<std::endl;
   
   konfi = nvt.konfidenz(alpha, sigma, n);
    
   std::cout.precision(14);
   std::cout << "G(u).....: " << std::fixed << innen << std::endl; 
   std::cout << "aplha= " << alpha << "   konfidenz ="  << konfi << std::endl; // G(u) als arg	 
   
   
   wouhi = 11;
  break;   
  
  case 4:
   std::cout << "Konfidenztest" << std::endl;
   
   std::cout << "n             Ee               Ew"  << std::endl;
   for (n = 1; n <= 15; n++)
    {
      Ee = nvt.konfidenz(0.01, 1, n); 
      Ew = nvt.konfidenz(0.05, 1, n);   
      std::cout << std::setw(3) << std::right << (int)n << "     " << std::setw(12)<< std::setprecision(8) << std::setfill('0') << std::left << Ee;
      std::cout <<  "     " << std::setw(12)<< std::setprecision(8) << std::setfill('0') << std::left << Ew <<std::endl;
    }   
 
   
   wouhi = 11;
  break; 
  
  case 5:
      std::cout << "CHI-Verteilung" << std::endl<< std::endl; 
      std::cout << "chi_square(1, 3).............: " << chi_square_distribution(1, 3) << std::endl; // 0.801252
      std::cout << "_chi_square(1, 3)............: " << _chi_square_distribution(1, 3) << std::endl; // 0.801252
      std::cout << "chivert(1, 3)................: " << chivert(1, 3) << std::endl; // 0.801252
      std::cout << "chi_square_inverse(0, 2).....: " << chi_square_inverse(0, 2) << std::endl; // 0     
      std::cout << "chi_square_inverse(0.5, 2)...: " << chi_square_inverse(0.5, 2) << std::endl;   // 1.38629
      std::cout << "chi_square_inverse(0.05, 5)..: " << chi_square_inverse(0.05, 5) << std::endl;   // 1.38629
      std::cout << "chiinv(0.05, 5)..............: " << chiinv(0.05, 5) << std::endl;   // 1.38629
      std::cout << "chi_square_inverse(0.05, 2)..: " << chi_square_inverse(0.05, 2) << std::endl; // 5.99147
      std::cout << "chi_square_inverse(0.7, 10)..: " << chi_square_inverse(0.7, 10) << std::endl; // 7.26722
      std::cout << "chi_square_inverse(0.1, 20)..: " << chi_square_inverse(0.1, 20) << std::endl; // 28.4122
      std::cout << "s-karte  0.005 zu 2......: " << Get_sKartenLimit(0.005, 2)<< std::endl;
      std::cout << "s-karte 0.025 zu 3......: " << Get_sKartenLimit(0.025, 13)<< std::endl;
     wouhi = 11;
  break; 
  


  case 6:
      std::cout << "\nTests  s-Karten-Werte:\n";
      std::cout << "n        an            OEG              OWG              UWG             UEG\n";
  
      for(n = 2; n <= 25; n++)
       {
        an = sKarte_anWert(n);
        oe = Get_sKartenLimit(OEG, n); 
        ow = Get_sKartenLimit(OWG, n); 
        uw = Get_sKartenLimit(UWG, n); 
        ue = Get_sKartenLimit(UEG, n); 
       std::cout << std::setw(3) << std::left << n << "   ";
       std::cout << std::left << std::setw(14) << std::setprecision(11) << an << "   ";
       std::cout << std::setw(14) << std::setprecision(11) << std::left << oe << "   ";
       std::cout << dblout (14, 11, ow) << "  ";
       std::cout << dblout (14, 11, uw) << "  ";
       std::cout << dblout (14, 11, ue) << std::endl;
      }   
     wouhi = 11;
    break; 
  

  case 7:
     gu = NORM_S_VERT(1.333333);
     std::cout << "NORM_S_VERT z=1.333333       " << std::setw(14) << std::setprecision(11) <<  gu << std::endl; // = e ^ 1.86511  
     gu = NORM_S_VERT(2.5758293064439);
     std::cout << "NORM_S_VERT 2=2.5758293064439 " << dblout (14, 11, gu) << std::endl;
     gu = NORM_S_VERT(2);
     std::cout << "NORM_S_VERT 2=2.0000000000000 " << dblout (14, 11, gu) << std::endl;
     wouhi = 11;
   break;
  
  case 8:
     std::cout << "Die Binomialverteilung beschreibt das Streuverhalten von Einheiten mit einer ganz" << std::endl; 
     std::cout << "bestimmten Merkmalsausprägung z.B. fehlerhaften Teilen. Mit ihr kann die" << std::endl;
     std::cout << "Wahrscheinlichkeit berechnet werden, in einer Stichprobe der Größe n genau x oder" << std::endl;
     std::cout << "aber bis zu x fehlerhafte Teile zu finden, wenn die Stichprobe aus einer" << std::endl; 
     std::cout << "Grundgesamtheit mit p% Merkmalsträger wird." << std::endl;
     std::cout <<"P=0.04     n=8" << std::endl;
     std::cout <<"x       g(x)      Gx(x) " << std::endl;
     
     
     for (x = 0; x <= 3; x++)
      {    
       kgx = Klein_gx(8, x, 0.04);
       ggx = Gross_gx(8, x, 0.04);
       //dblout(12, 8);
       std::cout << x << "  " << dblout (12, 8, kgx) << "   " << dblout (12, 8, ggx) << std::endl;
      }
     wouhi = 11; 
  break;
 
   
  case 9:
    std::cout << "Poissonverteilung" << std::endl;
    erklaerung();
    std::cout << "x = Anzahl von Fehlern in einer Stichprobe" << std::endl;
    std::cout << "P = Anteil von fehlerhafter Einheiten in der Grundgesamtheit" << std::endl;
    std::cout << "n = Stichprobenumfang" << std::endl;
    std::cout << "µ = p * n" << std::endl;
    Eingabe(&x, &mue);  
    xgross = Poisson_gross(x, mue);
    xklein = Poisson_klein(x, mue);
    std::cout << "Ergebnis G(x): " << xgross << std::endl;
    std::cout << "Ergebnis g(x): " << xklein << std::endl;
    wouhi = 11; 
  break;
  


 }while(wouhi != 0);

 return 0;
}

/******************* Ende des Hauptprogramms ******************/

