#include "normsvert.h"

// Wahrscheinlichkeitsdichtefunktion der standartisierten Normalverteilung g(u)
// Das Excel-Equivalent wäre NORM.S.VERT(z,FALSCH) also NORM.S.VERT(z, 0)
double NORM_S_VERT(double z)
{	
 double quot = 0, wurzel, e, zqh, erge = 0;
  //erge = 0.164082975127721 -> bei falsch und 1.333 als z;
  //z = 2.58; //758293064439;  2,5758293064439
  
 wurzel = sqrt(2 * M_PI);
 quot = 1 / wurzel; 
 e = exp(1);
 zqh = 0 - ((z * z) / 2);
 erge = quot * pow(e, zqh);
 
 return erge;
} 