/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.cc
 * Copyright (C) 2019 Josef Wismeth <josef.wismeth@t-online.de>
 * 
 * norminv2-cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * norminv2-cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <iostream>
#include "norminv.h"


int main()
{
 NormalDistributionConfidenceCalculator nvt;
 double wert, innen;
 int wouhi = 8;
 double my, x, sigma = 1, guqu;

 
 do
 switch(wouhi)
 {
   default:
     std::cout << std::endl << "Standardisierte Normalverteilung" << std::endl;
     std::cout << "Ende...........................0" << std::endl;
     std::cout << "Werte Normert Berechnen........1" << std::endl;
	 std::cout << "Werte Norminv Berechnen........2" << std::endl;	 
     std::cout << "Ihre Wahl: ";
     std::cin >> wouhi;
     if ((wouhi < 0 ) || (wouhi > 2)) wouhi = 1;
     break;

case 0:
     std::cout << "Programmende " << std::endl;
     return EXIT_SUCCESS;
    break;

case 1:
   std::cout << "My eingeben: ";
   std::cin >> my;
   std::cout << " x eingeben: ";
   std::cin >> x;
   std::cout <<" sigma: ";
   std::cin >> sigma;
   if((sigma <= 0) || (sigma > 1)) sigma = 1;
		
 
	 
   wert = nvt.NormalDistribution(my, x, 1);
   innen = 1 - wert;
   std::cout.precision(14);
   std::cout << "Q(u).....: " << std::fixed << wert<< std::endl;
   std::cout << "G(u).....: " << std::fixed << innen << std::endl; 
   std::cout << "G(u)-Q(u): " << std::fixed << innen - wert << std::endl; 
   std::cout << "g(u).....: " << nvt.NORM_S_VERT(x - my) << std::endl;
   wouhi = 8;

  break;

  case 2:
   std::cout << "G(u)-Q(u): ";
   std::cin >> guqu;

   if((guqu <= 0) || (guqu > 1)) sigma = 0.995;
		
   wert = nvt.NormalDistribution(my, x, 1);

   wert = ((1 - guqu) / 2);	

   innen = 1 - wert;		 

   std::cout.precision(14);
   std::cout << "G(u) g(u): " << nvt.NormInv(innen) << std::endl; // G(u) als arg	 
   std::cout << "G(u).....: " << std::fixed << innen << std::endl; 		 
   std::cout << "Q(u).....: " << std::fixed << wert<< std::endl;
   std::cout << "G(u)-Q(u): " << std::fixed << innen - wert << std::endl; 
   
   wouhi = 8;

  break;
	 

 }while(wouhi != 0);

 return 0;
}

/******************* Ende des Hauptprogramms ******************/
